package com.example.ueberwachungssystem;

import android.content.Context;
import android.media.MediaRecorder;
import android.os.Environment;

import androidx.camera.core.Camera;

import java.io.File;
import java.io.IOException;

public class Recorder {

    Context context;
    MediaRecorder mediaRecorder = null;

    public Recorder (Context context) {
        this.context = context;
    }


    public void startRecording() {

        mediaRecorder = new MediaRecorder();

        mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
        mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
        mediaRecorder.setOutputFile(context.getFilesDir() + "/audio.gpp");
        mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);



        try {
            mediaRecorder.prepare();
        } catch (IOException e) {
            e.printStackTrace();
        }
        mediaRecorder.start();
    }

    public void stopRecording() {
        if (mediaRecorder != null) {
            mediaRecorder.stop();
            mediaRecorder.reset();
            mediaRecorder.release();
            mediaRecorder = null;
        }
    }



    private void initMediaRecorder() {
        // Set the audio and video source
        mediaRecorder.setAudioSource(MediaRecorder.AudioSource.DEFAULT);
        mediaRecorder.setVideoSource(MediaRecorder.VideoSource.DEFAULT);

        // Set the output format and file path
        mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);
        //String videoFilePath = getOutputMediaFilePath(); // Custom method to get the output file path
        mediaRecorder.setOutputFile(context.getFilesDir());

        // Set the video encoder and audio encoder
        mediaRecorder.setVideoEncoder(MediaRecorder.VideoEncoder.DEFAULT);
        mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.DEFAULT);

        // Configure video size, frame rate, and other settings as needed
        mediaRecorder.setVideoSize(640, 480); // Set the desired video size
        mediaRecorder.setVideoFrameRate(30); // Set the desired frame rate
    }


    private String getOutputMediaFilePath() {
        String videoFileName = "Video.mp4";
        File storageDir = context.getFilesDir();

        if (!storageDir.exists()) {
            storageDir.mkdirs();
        }

        return storageDir.getAbsolutePath() + "/" + videoFileName;
    }
}
